/*
 * SMBus driver for ACPI Embedded Controller ($Revision: 1.2 $)
 *
 * Copyright (c) 2002, 2005 Ducrot Bruno
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation version 2.
 */

#define I2C_SMBUS_WORD_DATA_PEC      11           /* SMBus 2.0 */
#define I2C_SMBUS_BLOCK_DATA_PEC    8             /* SMBus 2.0 */
#define I2C_SMBUS_PROC_CALL_PEC     9             /* SMBus 2.0 */
#define I2C_SMBUS_BLOCK_PROC_CALL_PEC  10 /* SMBus 2.0 */
#define I2C_FUNC_SMBUS_WORD_DATA_PEC  I2C_FUNC_SMBUS_READ_WORD_DATA_PEC | \
                                      I2C_FUNC_SMBUS_WRITE_WORD_DATA_PEC
#define I2C_FUNC_SMBUS_READ_WORD_DATA_PEC  0x00000800 /* SMBus 2.0 */
#define I2C_FUNC_SMBUS_WRITE_WORD_DATA_PEC 0x00001000 /* SMBus 2.0 */
#define I2C_FUNC_SMBUS_BLOCK_DATA_PEC I2C_FUNC_SMBUS_READ_BLOCK_DATA_PEC | \
                                      I2C_FUNC_SMBUS_WRITE_BLOCK_DATA_PEC
#define I2C_FUNC_SMBUS_READ_BLOCK_DATA_PEC  0x40000000 /* SMBus 2.0 */
#define I2C_FUNC_SMBUS_WRITE_BLOCK_DATA_PEC 0x80000000 /* SMBus 2.0 */
#define I2C_FUNC_SMBUS_PROC_CALL_PEC    0x00002000 /* SMBus 2.0 */
#define I2C_FUNC_SMBUS_BLOCK_PROC_CALL_PEC 0x00004000 /* SMBus 2.0 */
#define I2C_ALGO_SMBUS 0x040000


struct acpi_ec {
	acpi_handle			handle;
	unsigned long			uid;
	unsigned long			gpe_bit;
	struct acpi_generic_address	status_addr;
	struct acpi_generic_address	command_addr;
	struct acpi_generic_address	data_addr;
	unsigned long			global_lock;
	spinlock_t			lock;
};

struct acpi_ec_smbus {
	struct i2c_adapter adapter;
	struct acpi_ec  *ec;
	int             base;
	int		alert;
};

struct acpi_ec_hc {
	acpi_handle			handle;
	struct acpi_ec_smbus		*smbus;
};
